/*
 * Copyright (c) 2017, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Author: Éder F. Zulian
 */

#include "PreBChecker.h"
#include "../../TimingCalculation.h"
void PreBChecker::delayToSatisfyConstraints(ScheduledCommand &cmd)const
{
    sc_assert(cmd.getCommand() == Command::PreB);
    ScheduledCommand lastCmd = state.getLastScheduledCommand(cmd.getBank());
    if (lastCmd.isValidCommand()) {
        if (lastCmd.getCommand() == Command::PreB) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(),
                                              Configuration::getInstance().getTrpb());
        } else if (lastCmd.getCommand() == Command::Precharge) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(), config.memSpec.tRP);
        } else if (lastCmd.getCommand() == Command::PrechargeAll) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(), config.memSpec.tRP);
        } else if (lastCmd.getCommand() == Command::ActB) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(),
                                              config.memSpec.tRCD); // XXX: trcd is less than the NEW! trasb! ok!
        } else if (lastCmd.getCommand() == Command::Activate) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(), config.memSpec.tRCD);
        } else if (lastCmd.getCommand() == Command::Read) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(), config.memSpec.tRTP);
        } else if (lastCmd.getCommand() == Command::Write) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(),
                                              config.memSpec.tWL + getWriteAccessTime() + config.memSpec.tWR);
        } else if (lastCmd.getCommand() == Command::PDNAX) {
            cmd.establishMinDistanceFromStart(lastCmd.getStart(), config.memSpec.tXP);
        } else {
            reportFatal("PreB Checker",
                        "PreB can not follow " + commandToString(lastCmd.getCommand()));
        }
    }
    ScheduledCommand lc;
    if ((lc = state.getLastCommand(Command::PrechargeAll)).isValidCommand()) {
        cmd.establishMinDistanceFromStart(lc.getStart(), config.memSpec.tRP);
    }
    if ((lc = state.getLastCommand(Command::Activate,
                                   cmd.getBank())).isValidCommand()) {
        cmd.establishMinDistanceFromStart(lc.getStart(), config.memSpec.tRAS);
    }
    if ((lc = state.getLastCommand(Command::ActB,
                                   cmd.getBank())).isValidCommand()) {
        cmd.establishMinDistanceFromStart(lc.getStart(),
                                          Configuration::getInstance().getTrasb());
    }
    state.bus.moveCommandToNextFreeSlot(cmd);
}
